blob: f1875d71a57a0f4db873234c53d583b2d52f9e9a [file] [log] [blame]
jeffhao5d1ac922011-09-29 17:41:15 -07001#!/bin/bash
2#
3# Copyright (C) 2007 The Android Open Source Project
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17# Set up prog to be the path of this script, including following symlinks,
18# and set up progdir to be the fully-qualified pathname of its directory.
19prog="$0"
Andreas Gampedeb48a02014-10-22 00:44:35 -070020args="$@"
jeffhao5d1ac922011-09-29 17:41:15 -070021while [ -h "${prog}" ]; do
22 newProg=`/bin/ls -ld "${prog}"`
23 newProg=`expr "${newProg}" : ".* -> \(.*\)$"`
24 if expr "x${newProg}" : 'x/' >/dev/null; then
25 prog="${newProg}"
26 else
27 progdir=`dirname "${prog}"`
28 prog="${progdir}/${newProg}"
29 fi
30done
31oldwd=`pwd`
32progdir=`dirname "${prog}"`
33cd "${progdir}"
34progdir=`pwd`
35prog="${progdir}"/`basename "${prog}"`
Brian Carlstrom105215d2012-06-14 12:50:44 -070036test_dir="test-$$"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070037if [ -z "$TMPDIR" ]; then
38 tmp_dir="/tmp/$USER/${test_dir}"
39else
40 tmp_dir="${TMPDIR}/$USER/${test_dir}"
41fi
David Brazdil2c27f2c2015-05-12 18:06:38 +010042checker="${progdir}/../tools/checker/checker.py"
jeffhao5d1ac922011-09-29 17:41:15 -070043export JAVA="java"
Vladimir Markof45c3f82015-12-15 16:36:24 +000044export JAVAC="javac -g -source 1.7 -target 1.7 -Xlint:-options"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010045export RUN="${progdir}/etc/run-test-jar"
Brian Carlstrom105215d2012-06-14 12:50:44 -070046export DEX_LOCATION=/data/run-test/${test_dir}
Elliott Hughesc717eef2012-06-15 16:01:26 -070047export NEED_DEX="true"
Sebastien Hertz19ac0272015-02-24 17:39:50 +010048export USE_JACK="false"
Alex Light8a0e0332015-10-26 10:11:58 -070049export SMALI_ARGS="--experimental --api-level 23"
jeffhao5d1ac922011-09-29 17:41:15 -070050
Tsu Chiang Chuang4407e612012-07-19 16:13:43 -070051# If dx was not set by the environment variable, assume it is in the path.
52if [ -z "$DX" ]; then
53 export DX="dx"
54fi
55
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080056# If jasmin was not set by the environment variable, assume it is in the path.
57if [ -z "$JASMIN" ]; then
58 export JASMIN="jasmin"
59fi
60
Andreas Gampe8fda9f22014-10-03 16:15:37 -070061# If smali was not set by the environment variable, assume it is in the path.
62if [ -z "$SMALI" ]; then
63 export SMALI="smali"
64fi
65
66# If dexmerger was not set by the environment variable, assume it is in the path.
67if [ -z "$DXMERGER" ]; then
68 export DXMERGER="dexmerger"
69fi
70
Sebastien Hertz19ac0272015-02-24 17:39:50 +010071# If jack was not set by the environment variable, assume it is in the path.
72if [ -z "$JACK" ]; then
73 export JACK="jack"
74fi
75
76# If the tree is compiled with Jack, build test with Jack by default.
77if [ "$ANDROID_COMPILE_WITH_JACK" = "true" ]; then
78 USE_JACK="true"
79fi
80
81# ANDROID_BUILD_TOP is not set in a build environment.
82if [ -z "$ANDROID_BUILD_TOP" ]; then
83 export ANDROID_BUILD_TOP=$oldwd
84fi
85
Sebastien Hertz19ac0272015-02-24 17:39:50 +010086# If JACK_CLASSPATH is not set, assume it only contains core-libart.
87if [ -z "$JACK_CLASSPATH" ]; then
Przemyslaw Szczepaniak121b25e2015-11-20 11:24:33 +000088 export JACK_CLASSPATH="${OUT_DIR:-$ANDROID_BUILD_TOP/out}/host/common/obj/JAVA_LIBRARIES/core-libart-hostdex_intermediates/classes.jack:${OUT_DIR:-$ANDROID_BUILD_TOP/out}/host/common/obj/JAVA_LIBRARIES/core-oj-hostdex_intermediates/classes.jack"
Sebastien Hertz19ac0272015-02-24 17:39:50 +010089fi
90
Sebastien Hertz19ac0272015-02-24 17:39:50 +010091export JACK="$JACK -g -cp $JACK_CLASSPATH"
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080092
jeffhao5d1ac922011-09-29 17:41:15 -070093info="info.txt"
94build="build"
95run="run"
96expected="expected.txt"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -070097check_cmd="check"
jeffhao5d1ac922011-09-29 17:41:15 -070098output="output.txt"
99build_output="build-output.txt"
David Brazdil24128c62015-05-21 12:06:13 +0100100cfg_output="graph.cfg"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700101strace_output="strace-output.txt"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700102lib="libartd.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700103testlib="arttestd"
jeffhao5d1ac922011-09-29 17:41:15 -0700104run_args="--quiet"
David Brazdil4846d132015-01-15 19:07:08 +0000105build_args=""
jeffhao5d1ac922011-09-29 17:41:15 -0700106
Alex Light91de25f2015-10-28 17:00:06 -0700107quiet="no"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000108debuggable="no"
Alex Light9d722532014-07-22 18:07:12 -0700109prebuild_mode="yes"
Brian Carlstrom2613de42012-06-15 17:37:16 -0700110target_mode="yes"
jeffhao5d1ac922011-09-29 17:41:15 -0700111dev_mode="no"
112update_mode="no"
Alex Lighta59dd802014-07-02 16:28:08 -0700113debug_mode="no"
114relocate="yes"
Jeff Hao201803f2013-11-20 18:11:39 -0800115runtime="art"
jeffhao5d1ac922011-09-29 17:41:15 -0700116usage="no"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700117build_only="no"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700118suffix64=""
Jeff Hao85139a32014-07-23 11:52:52 -0700119trace="false"
Andreas Gampe7526d782015-06-22 22:53:45 -0700120trace_stream="false"
Alex Lighte7873ec2014-08-12 09:53:50 -0700121basic_verify="false"
122gc_verify="false"
123gc_stress="false"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700124strace="false"
Alex Lightbfac14a2014-07-30 09:41:21 -0700125always_clean="no"
Igor Murashkin05f30e12015-06-10 15:57:17 -0700126never_clean="no"
Alex Light03a112d2014-08-25 13:25:56 -0700127have_dex2oat="yes"
128have_patchoat="yes"
129have_image="yes"
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700130image_suffix=""
Andreas Gampec23c9c92014-10-28 14:47:25 -0700131pic_image_suffix=""
Jeff Haodcdc85b2015-12-04 14:06:18 -0800132multi_image_suffix=""
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000133android_root="/system"
jeffhao5d1ac922011-09-29 17:41:15 -0700134
135while true; do
136 if [ "x$1" = "x--host" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700137 target_mode="no"
TDYa127b92bcab2012-04-08 00:09:51 -0700138 DEX_LOCATION=$tmp_dir
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100139 run_args="${run_args} --host"
jeffhao5d1ac922011-09-29 17:41:15 -0700140 shift
Alex Light91de25f2015-10-28 17:00:06 -0700141 elif [ "x$1" = "x--quiet" ]; then
142 quiet="yes"
143 shift
Alex Lighteb7c1442015-08-31 13:17:42 -0700144 elif [ "x$1" = "x--use-java-home" ]; then
145 if [ -n "${JAVA_HOME}" ]; then
146 export JAVA="${JAVA_HOME}/bin/java"
147 export JAVAC="${JAVA_HOME}/bin/javac -g"
148 else
149 echo "Passed --use-java-home without JAVA_HOME variable set!"
150 usage="yes"
151 fi
152 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800153 elif [ "x$1" = "x--jvm" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700154 target_mode="no"
Jeff Hao201803f2013-11-20 18:11:39 -0800155 runtime="jvm"
Brian Carlstrom01afdba2014-10-03 10:28:47 -0700156 prebuild_mode="no"
Elliott Hughesc717eef2012-06-15 16:01:26 -0700157 NEED_DEX="false"
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100158 USE_JACK="false"
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100159 run_args="${run_args} --jvm"
Alex Lighteb7c1442015-08-31 13:17:42 -0700160 build_args="${build_args} --jvm"
jeffhao5d1ac922011-09-29 17:41:15 -0700161 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800162 elif [ "x$1" = "x-O" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700163 lib="libart.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700164 testlib="arttest"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700165 shift
166 elif [ "x$1" = "x--dalvik" ]; then
167 lib="libdvm.so"
Jeff Hao201803f2013-11-20 18:11:39 -0800168 runtime="dalvik"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700169 shift
Alex Light03a112d2014-08-25 13:25:56 -0700170 elif [ "x$1" = "x--no-dex2oat" ]; then
171 have_dex2oat="no"
172 shift
173 elif [ "x$1" = "x--no-patchoat" ]; then
174 have_patchoat="no"
175 shift
176 elif [ "x$1" = "x--no-image" ]; then
177 have_image="no"
178 shift
Andreas Gampec23c9c92014-10-28 14:47:25 -0700179 elif [ "x$1" = "x--pic-image" ]; then
180 pic_image_suffix="-pic"
181 shift
Jeff Haodcdc85b2015-12-04 14:06:18 -0800182 elif [ "x$1" = "x--multi-image" ]; then
183 multi_image_suffix="-multi"
184 shift
Andreas Gampec23c9c92014-10-28 14:47:25 -0700185 elif [ "x$1" = "x--pic-test" ]; then
186 run_args="${run_args} --pic-test"
187 shift
Alex Lighta59dd802014-07-02 16:28:08 -0700188 elif [ "x$1" = "x--relocate" ]; then
189 relocate="yes"
190 shift
191 elif [ "x$1" = "x--no-relocate" ]; then
192 relocate="no"
193 shift
194 elif [ "x$1" = "x--prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100195 run_args="${run_args} --prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700196 prebuild_mode="yes"
197 shift;
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000198 elif [ "x$1" = "x--debuggable" ]; then
199 run_args="${run_args} -Xcompiler-option --debuggable"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000200 debuggable="yes"
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000201 shift;
Alex Lighta59dd802014-07-02 16:28:08 -0700202 elif [ "x$1" = "x--no-prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100203 run_args="${run_args} --no-prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700204 prebuild_mode="no"
205 shift;
Alex Lighte7873ec2014-08-12 09:53:50 -0700206 elif [ "x$1" = "x--gcverify" ]; then
207 basic_verify="true"
208 gc_verify="true"
209 shift
210 elif [ "x$1" = "x--gcstress" ]; then
211 basic_verify="true"
212 gc_stress="true"
213 shift
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700214 elif [ "x$1" = "x--image" ]; then
215 shift
216 image="$1"
217 run_args="${run_args} --image $image"
Elliott Hughes7c046102011-10-19 18:16:03 -0700218 shift
Nicolas Geoffray92cf83e2014-03-18 17:59:20 +0000219 elif [ "x$1" = "x-Xcompiler-option" ]; then
220 shift
221 option="$1"
222 run_args="${run_args} -Xcompiler-option $option"
223 shift
Mathieu Chartier769a5ad2014-05-18 15:30:10 -0700224 elif [ "x$1" = "x--runtime-option" ]; then
225 shift
226 option="$1"
227 run_args="${run_args} --runtime-option $option"
228 shift
Mathieu Chartierc0a8a802014-10-17 15:58:01 -0700229 elif [ "x$1" = "x--gdb-arg" ]; then
230 shift
231 gdb_arg="$1"
232 run_args="${run_args} --gdb-arg $gdb_arg"
233 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700234 elif [ "x$1" = "x--debug" ]; then
235 run_args="${run_args} --debug"
236 shift
237 elif [ "x$1" = "x--gdb" ]; then
238 run_args="${run_args} --gdb"
239 dev_mode="yes"
240 shift
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700241 elif [ "x$1" = "x--strace" ]; then
242 strace="yes"
243 run_args="${run_args} --invoke-with strace --invoke-with -o --invoke-with $tmp_dir/$strace_output"
244 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700245 elif [ "x$1" = "x--zygote" ]; then
246 run_args="${run_args} --zygote"
247 shift
jeffhao0dff3f42012-11-20 15:13:43 -0800248 elif [ "x$1" = "x--interpreter" ]; then
249 run_args="${run_args} --interpreter"
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700250 image_suffix="-interpreter"
251 shift
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800252 elif [ "x$1" = "x--jit" ]; then
253 run_args="${run_args} --jit"
Andreas Gampe8a159fd2015-09-21 15:14:38 -0700254 image_suffix="-jit"
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800255 shift
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700256 elif [ "x$1" = "x--optimizing" ]; then
257 run_args="${run_args} -Xcompiler-option --compiler-backend=Optimizing"
258 image_suffix="-optimizing"
jeffhao0dff3f42012-11-20 15:13:43 -0800259 shift
Nicolas Geoffrayc9338b92014-12-03 13:36:10 +0000260 elif [ "x$1" = "x--quick" ]; then
261 run_args="${run_args} -Xcompiler-option --compiler-backend=Quick"
262 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700263 elif [ "x$1" = "x--no-verify" ]; then
264 run_args="${run_args} --no-verify"
265 shift
Igor Murashkin7617abd2015-07-10 18:27:47 -0700266 elif [ "x$1" = "x--verify-soft-fail" ]; then
267 run_args="${run_args} --verify-soft-fail"
Andreas Gampe825570c2015-07-26 10:26:03 -0700268 image_suffix="-interp-ac"
Igor Murashkin7617abd2015-07-10 18:27:47 -0700269 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700270 elif [ "x$1" = "x--no-optimize" ]; then
271 run_args="${run_args} --no-optimize"
272 shift
273 elif [ "x$1" = "x--no-precise" ]; then
274 run_args="${run_args} --no-precise"
275 shift
Elliott Hughes7c046102011-10-19 18:16:03 -0700276 elif [ "x$1" = "x--invoke-with" ]; then
277 shift
278 what="$1"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700279 if [ "x$what" = "x" ]; then
280 echo "$0 missing argument to --invoke-with" 1>&2
281 usage="yes"
282 break
283 fi
Ian Rogers0e033672013-04-19 10:22:46 -0700284 run_args="${run_args} --invoke-with ${what}"
jeffhao5d1ac922011-09-29 17:41:15 -0700285 shift
286 elif [ "x$1" = "x--dev" ]; then
287 run_args="${run_args} --dev"
288 dev_mode="yes"
289 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700290 elif [ "x$1" = "x--build-only" ]; then
291 build_only="yes"
292 shift
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100293 elif [ "x$1" = "x--build-with-javac-dx" ]; then
294 USE_JACK="false"
295 shift
296 elif [ "x$1" = "x--build-with-jack" ]; then
297 USE_JACK="true"
298 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700299 elif [ "x$1" = "x--output-path" ]; then
300 shift
301 tmp_dir=$1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700302 if [ "x$tmp_dir" = "x" ]; then
303 echo "$0 missing argument to --output-path" 1>&2
304 usage="yes"
305 break
306 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700307 shift
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000308 elif [ "x$1" = "x--android-root" ]; then
309 shift
310 if [ "x$1" = "x" ]; then
311 echo "$0 missing argument to --android-root" 1>&2
312 usage="yes"
313 break
314 fi
315 android_root="$1"
316 run_args="${run_args} --android-root $1"
317 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700318 elif [ "x$1" = "x--update" ]; then
319 update_mode="yes"
320 shift
321 elif [ "x$1" = "x--help" ]; then
322 usage="yes"
323 shift
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700324 elif [ "x$1" = "x--64" ]; then
325 run_args="${run_args} --64"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700326 suffix64="64"
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700327 shift
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200328 elif [ "x$1" = "x--trace" ]; then
Jeff Hao85139a32014-07-23 11:52:52 -0700329 trace="true"
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200330 shift
Andreas Gampe7526d782015-06-22 22:53:45 -0700331 elif [ "x$1" = "x--stream" ]; then
332 trace_stream="true"
333 shift
Alex Lightbfac14a2014-07-30 09:41:21 -0700334 elif [ "x$1" = "x--always-clean" ]; then
335 always_clean="yes"
336 shift
Igor Murashkin05f30e12015-06-10 15:57:17 -0700337 elif [ "x$1" = "x--never-clean" ]; then
338 never_clean="yes"
339 shift
Andreas Gampee21dc3d2014-12-08 16:59:43 -0800340 elif [ "x$1" = "x--dex2oat-swap" ]; then
341 run_args="${run_args} --dex2oat-swap"
342 shift
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700343 elif [ "x$1" = "x--instruction-set-features" ]; then
344 shift
345 run_args="${run_args} --instruction-set-features $1"
346 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700347 elif expr "x$1" : "x--" >/dev/null 2>&1; then
Elliott Hughes7c046102011-10-19 18:16:03 -0700348 echo "unknown $0 option: $1" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700349 usage="yes"
350 break
351 else
352 break
353 fi
354done
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700355
Alex Light91de25f2015-10-28 17:00:06 -0700356# Allocate file descriptor real_stderr and redirect it to the shell's error
357# output (fd 2).
358if [ ${BASH_VERSINFO[1]} -ge 4 ] && [ ${BASH_VERSINFO[2]} -ge 1 ]; then
359 exec {real_stderr}>&2
360else
361 # In bash before version 4.1 we need to do a manual search for free file
362 # descriptors.
363 FD=3
364 while [ -e /dev/fd/$FD ]; do FD=$((FD + 1)); done
365 real_stderr=$FD
366 eval "exec ${real_stderr}>&2"
367fi
368if [ "$quiet" = "yes" ]; then
369 # Force the default standard output and error to go to /dev/null so we will
370 # not print them.
371 exec 1>/dev/null
372 exec 2>/dev/null
373fi
374
375function err_echo() {
376 echo "$@" 1>&${real_stderr}
377}
378
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700379# tmp_dir may be relative, resolve.
380#
381# Cannot use realpath, as it does not exist on Mac.
382# Cannot us a simple "cd", as the path might not be created yet.
Brian Carlstromc580e042014-09-08 21:37:39 -0700383# Cannot use readlink -m, as it does not exist on Mac.
384# Fallback to nuclear option:
Andreas Gampe907b6992014-08-18 22:26:49 -0700385noncanonical_tmp_dir=$tmp_dir
Brian Carlstromc580e042014-09-08 21:37:39 -0700386tmp_dir="`cd $oldwd ; python -c "import os; print os.path.realpath('$tmp_dir')"`"
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +0700387mkdir -p $tmp_dir
jeffhao5d1ac922011-09-29 17:41:15 -0700388
Alex Lighte7873ec2014-08-12 09:53:50 -0700389if [ "$basic_verify" = "true" ]; then
Hiroshi Yamauchi312baf12015-01-12 12:11:05 -0800390 # Set HspaceCompactForOOMMinIntervalMs to zero to run hspace compaction for OOM more frequently in tests.
391 run_args="${run_args} --runtime-option -Xgc:preverify --runtime-option -Xgc:postverify --runtime-option -XX:HspaceCompactForOOMMinIntervalMs=0"
Alex Lighte7873ec2014-08-12 09:53:50 -0700392fi
393if [ "$gc_verify" = "true" ]; then
394 run_args="${run_args} --runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc"
395fi
396if [ "$gc_stress" = "true" ]; then
Mathieu Chartiereb193622015-06-27 15:42:27 -0700397 run_args="${run_args} --runtime-option -Xgc:SS,gcstress --runtime-option -Xms2m --runtime-option -Xmx16m"
Alex Lighte7873ec2014-08-12 09:53:50 -0700398fi
Jeff Hao85139a32014-07-23 11:52:52 -0700399if [ "$trace" = "true" ]; then
Andreas Gampe7526d782015-06-22 22:53:45 -0700400 run_args="${run_args} --runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file-size:2000000"
401 if [ "$trace_stream" = "true" ]; then
402 # Streaming mode uses the file size as the buffer size. So output gets really large. Drop
403 # the ability to analyze the file and just write to /dev/null.
404 run_args="${run_args} --runtime-option -Xmethod-trace-file:/dev/null"
405 # Enable streaming mode.
406 run_args="${run_args} --runtime-option -Xmethod-trace-stream"
407 else
408 run_args="${run_args} --runtime-option -Xmethod-trace-file:${DEX_LOCATION}/trace.bin"
409 fi
410elif [ "$trace_stream" = "true" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700411 err_echo "Cannot use --stream without --trace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700412 exit 1
Jeff Hao85139a32014-07-23 11:52:52 -0700413fi
414
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700415# Most interesting target architecture variables are Makefile variables, not environment variables.
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100416# Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name.
David Brazdil853a4c32015-09-28 16:15:50 +0100417function guess_target_arch_name() {
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100418 grep32bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm|x86|mips)$'`
Andreas Gampe1a5c4062015-01-15 12:10:47 -0800419 grep64bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm64|x86_64|mips64)$'`
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700420 if [ "x${suffix64}" = "x64" ]; then
421 target_arch_name=${grep64bit}
422 else
423 target_arch_name=${grep32bit}
424 fi
425}
426
David Brazdil853a4c32015-09-28 16:15:50 +0100427function guess_host_arch_name() {
428 if [ "x${suffix64}" = "x64" ]; then
429 host_arch_name="x86_64"
430 else
431 host_arch_name="x86"
432 fi
433}
434
Alex Lighta59dd802014-07-02 16:28:08 -0700435if [ "$target_mode" = "no" ]; then
436 if [ "$runtime" = "jvm" ]; then
Alex Lighta59dd802014-07-02 16:28:08 -0700437 if [ "$prebuild_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700438 err_echo "--prebuild with --jvm is unsupported"
Alex Lighta59dd802014-07-02 16:28:08 -0700439 exit 1;
440 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700441 fi
442fi
443
Alex Light03a112d2014-08-25 13:25:56 -0700444if [ "$have_patchoat" = "no" ]; then
445 run_args="${run_args} --no-patchoat"
446fi
447
448if [ "$have_dex2oat" = "no" ]; then
449 run_args="${run_args} --no-dex2oat"
450fi
451
Jeff Hao201803f2013-11-20 18:11:39 -0800452if [ ! "$runtime" = "jvm" ]; then
453 run_args="${run_args} --lib $lib"
454fi
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700455
Jeff Hao201803f2013-11-20 18:11:39 -0800456if [ "$runtime" = "dalvik" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700457 if [ "$target_mode" = "no" ]; then
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100458 framework="${ANDROID_PRODUCT_OUT}/system/framework"
Andreas Gampe50be66f2015-12-28 14:31:06 -0800459 bpath="${framework}/core-libart.jar:${framework}/core-oj.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/bouncycastle.jar:${framework}/ext.jar"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700460 run_args="${run_args} --boot -Xbootclasspath:${bpath}"
461 else
462 true # defaults to using target BOOTCLASSPATH
463 fi
Jeff Hao201803f2013-11-20 18:11:39 -0800464elif [ "$runtime" = "art" ]; then
465 if [ "$target_mode" = "no" ]; then
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100466 # ANDROID_HOST_OUT is not set in a build environment.
Brian Carlstrom43534862014-02-19 01:13:52 -0800467 if [ -z "$ANDROID_HOST_OUT" ]; then
Alex Light6a439bc2015-10-26 17:52:36 -0700468 export ANDROID_HOST_OUT=${OUT_DIR:-$ANDROID_BUILD_TOP/out/}host/linux-x86
Brian Carlstrom43534862014-02-19 01:13:52 -0800469 fi
David Brazdil853a4c32015-09-28 16:15:50 +0100470 guess_host_arch_name
Jeff Haodcdc85b2015-12-04 14:06:18 -0800471 run_args="${run_args} --boot ${ANDROID_HOST_OUT}/framework/core${image_suffix}${pic_image_suffix}${multi_image_suffix}.art"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700472 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib${suffix64}"
Jeff Hao201803f2013-11-20 18:11:39 -0800473 else
David Brazdil853a4c32015-09-28 16:15:50 +0100474 guess_target_arch_name
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700475 run_args="${run_args} --runtime-option -Djava.library.path=/data/art-test/${target_arch_name}"
Jeff Haodcdc85b2015-12-04 14:06:18 -0800476 run_args="${run_args} --boot /data/art-test/core${image_suffix}${pic_image_suffix}${multi_image_suffix}.art"
Jeff Hao201803f2013-11-20 18:11:39 -0800477 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700478 if [ "$relocate" = "yes" ]; then
479 run_args="${run_args} --relocate"
480 else
481 run_args="${run_args} --no-relocate"
482 fi
Andreas Gampe3f1dc562015-05-18 15:52:22 -0700483elif [ "$runtime" = "jvm" ]; then
484 # TODO: Detect whether the host is 32-bit or 64-bit.
485 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib64"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700486fi
487
Alex Light03a112d2014-08-25 13:25:56 -0700488if [ "$have_image" = "no" ]; then
Alex Light1ef4ce82014-08-27 11:13:47 -0700489 if [ "$runtime" != "art" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700490 err_echo "--no-image is only supported on the art runtime"
Alex Light1ef4ce82014-08-27 11:13:47 -0700491 exit 1
492 fi
493 if [ "$target_mode" = "no" ]; then
494 framework="${ANDROID_HOST_OUT}/framework"
495 bpath_suffix="-hostdex"
496 else
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000497 framework="${android_root}/framework"
Alex Light1ef4ce82014-08-27 11:13:47 -0700498 bpath_suffix=""
499 fi
500 # TODO If the target was compiled WITH_DEXPREOPT=true then these tests will
501 # fail since these jar files will be stripped.
502 bpath="${framework}/core-libart${bpath_suffix}.jar"
Narayan Kamathd50687e2015-11-17 12:37:27 +0000503 bpath="${bpath}:${framework}/core-oj${bpath_suffix}.jar"
Alex Light1ef4ce82014-08-27 11:13:47 -0700504 bpath="${bpath}:${framework}/conscrypt${bpath_suffix}.jar"
505 bpath="${bpath}:${framework}/okhttp${bpath_suffix}.jar"
Alex Light1ef4ce82014-08-27 11:13:47 -0700506 bpath="${bpath}:${framework}/bouncycastle${bpath_suffix}.jar"
507 # Pass down the bootclasspath
508 run_args="${run_args} --runtime-option -Xbootclasspath:${bpath}"
Alex Light03a112d2014-08-25 13:25:56 -0700509 run_args="${run_args} --no-image"
510fi
511
jeffhao5d1ac922011-09-29 17:41:15 -0700512if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700513 err_echo "--dev and --update are mutually exclusive"
514 usage="yes"
515fi
516
517if [ "$dev_mode" = "yes" -a "$quiet" = "yes" ]; then
518 err_echo "--dev and --quiet are mutually exclusive"
jeffhao5d1ac922011-09-29 17:41:15 -0700519 usage="yes"
520fi
521
522if [ "$usage" = "no" ]; then
523 if [ "x$1" = "x" -o "x$1" = "x-" ]; then
524 test_dir=`basename "$oldwd"`
525 else
526 test_dir="$1"
527 fi
528
529 if [ '!' -d "$test_dir" ]; then
530 td2=`echo ${test_dir}-*`
531 if [ '!' -d "$td2" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700532 err_echo "${test_dir}: no such test directory"
jeffhao5d1ac922011-09-29 17:41:15 -0700533 usage="yes"
534 fi
535 test_dir="$td2"
536 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700537 # Shift to get rid of the test name argument. The rest of the arguments
538 # will get passed to the test run.
539 shift
540fi
541
542if [ "$usage" = "yes" ]; then
543 prog=`basename $prog`
544 (
545 echo "usage:"
546 echo " $prog --help Print this message."
547 echo " $prog [options] [test-name] Run test normally."
548 echo " $prog --dev [options] [test-name] Development mode" \
549 "(dumps to stdout)."
550 echo " $prog --update [options] [test-name] Update mode" \
551 "(replaces expected.txt)."
552 echo ' Omitting the test name or specifying "-" will use the' \
553 "current directory."
554 echo " Runtime Options:"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000555 echo " -O Run non-debug rather than debug build (off by default)."
556 echo " -Xcompiler-option Pass an option to the compiler."
557 echo " --runtime-option Pass an option to the runtime."
558 echo " --debug Wait for a debugger to attach."
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000559 echo " --debuggable Whether to compile Java code for a debugger."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000560 echo " --gdb Run under gdb; incompatible with some tests."
Alex Lightfadfee92015-10-28 09:40:10 -0700561 echo " --gdb-arg Pass an option to gdb."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000562 echo " --build-only Build test files only (off by default)."
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100563 echo " --build-with-javac-dx Build test files with javac and dx (on by default)."
564 echo " --build-with-jack Build test files with jack and jill (off by default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000565 echo " --interpreter Enable interpreter only mode (off by default)."
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800566 echo " --jit Enable jit (off by default)."
Nicolas Geoffray0e071252015-03-21 13:43:15 +0000567 echo " --optimizing Enable optimizing compiler (default)."
568 echo " --quick Use Quick compiler (off by default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000569 echo " --no-verify Turn off verification (on by default)."
Igor Murashkin7617abd2015-07-10 18:27:47 -0700570 echo " --verify-soft-fail Force soft fail verification (off by default)."
571 echo " Verification is enabled if neither --no-verify"
572 echo " nor --verify-soft-fail is specified."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000573 echo " --no-optimize Turn off optimization (on by default)."
574 echo " --no-precise Turn off precise GC (on by default)."
575 echo " --zygote Spawn the process from the Zygote." \
jeffhao5d1ac922011-09-29 17:41:15 -0700576 "If used, then the"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000577 echo " other runtime options are ignored."
578 echo " --no-dex2oat Run as though dex2oat was failing."
579 echo " --no-patchoat Run as though patchoat was failing."
580 echo " --prebuild Run dex2oat on the files before starting test. (default)"
581 echo " --no-prebuild Do not run dex2oat on the files before starting"
582 echo " the test."
583 echo " --relocate Force the use of relocating in the test, making"
584 echo " the image and oat files be relocated to a random"
585 echo " address before running. (default)"
586 echo " --no-relocate Force the use of no relocating in the test"
Alex Lightfadfee92015-10-28 09:40:10 -0700587 echo " --image Run the test using a precompiled boot image. (default)"
588 echo " --no-image Run the test without a precompiled boot image."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000589 echo " --host Use the host-mode virtual machine."
590 echo " --invoke-with Pass --invoke-with option to runtime."
591 echo " --dalvik Use Dalvik (off by default)."
592 echo " --jvm Use a host-local RI virtual machine."
Alex Lighteb7c1442015-08-31 13:17:42 -0700593 echo " --use-java-home Use the JAVA_HOME environment variable"
594 echo " to find the java compiler and runtime"
595 echo " (if applicable) to run the test with."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000596 echo " --output-path [path] Location where to store the build" \
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700597 "files."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000598 echo " --64 Run the test in 64-bit mode"
599 echo " --trace Run with method tracing"
Alex Lightfadfee92015-10-28 09:40:10 -0700600 echo " --strace Run with syscall tracing from strace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700601 echo " --stream Run method tracing in streaming mode (requires --trace)"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000602 echo " --gcstress Run with gc stress testing"
603 echo " --gcverify Run with gc verification"
604 echo " --always-clean Delete the test files even if the test fails."
Igor Murashkin05f30e12015-06-10 15:57:17 -0700605 echo " --never-clean Keep the test files even if the test succeeds."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000606 echo " --android-root [path] The path on target for the android root. (/system by default)."
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000607 echo " --dex2oat-swap Use a dex2oat swap file."
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700608 echo " --instruction-set-features [string]"
609 echo " Set instruction-set-features for compilation."
Alex Lightfadfee92015-10-28 09:40:10 -0700610 echo " --pic-image Use an image compiled with position independent code for the"
611 echo " boot class path."
Jeff Haodcdc85b2015-12-04 14:06:18 -0800612 echo " --multi-image Use a set of images compiled with dex2oat multi-image for"
613 echo " the boot class path."
Alex Lightfadfee92015-10-28 09:40:10 -0700614 echo " --pic-test Compile the test code position independent."
Alex Light91de25f2015-10-28 17:00:06 -0700615 echo " --quiet Don't print anything except failure messages"
616 ) 1>&2 # Direct to stderr so usage is not printed if --quiet is set.
jeffhao5d1ac922011-09-29 17:41:15 -0700617 exit 1
618fi
619
620cd "$test_dir"
621test_dir=`pwd`
622
623td_info="${test_dir}/${info}"
624td_expected="${test_dir}/${expected}"
625
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700626if [ ! -r $td_info ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700627 err_echo "${test_dir}: missing file $td_info"
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700628 exit 1
629fi
630
631if [ ! -r $td_expected ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700632 err_echo "${test_dir}: missing file $td_expected"
jeffhao5d1ac922011-09-29 17:41:15 -0700633 exit 1
634fi
635
636# copy the test to a temp dir and run it
637
Elliott Hughes510c8782011-10-06 10:57:34 -0700638echo "${test_dir}: building..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700639
640rm -rf "$tmp_dir"
641cp -Rp "$test_dir" "$tmp_dir"
642cd "$tmp_dir"
643
644if [ '!' -r "$build" ]; then
645 cp "${progdir}/etc/default-build" build
Zheng Xuc6667102015-05-15 16:08:45 +0800646else
647 cp "${progdir}/etc/default-build" .
jeffhao5d1ac922011-09-29 17:41:15 -0700648fi
649
650if [ '!' -r "$run" ]; then
651 cp "${progdir}/etc/default-run" run
Zheng Xuc6667102015-05-15 16:08:45 +0800652else
653 cp "${progdir}/etc/default-run" .
jeffhao5d1ac922011-09-29 17:41:15 -0700654fi
655
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700656if [ '!' -r "$check_cmd" ]; then
657 cp "${progdir}/etc/default-check" check
Zheng Xuc6667102015-05-15 16:08:45 +0800658else
659 cp "${progdir}/etc/default-check" .
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700660fi
661
jeffhao5d1ac922011-09-29 17:41:15 -0700662chmod 755 "$build"
663chmod 755 "$run"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700664chmod 755 "$check_cmd"
jeffhao5d1ac922011-09-29 17:41:15 -0700665
Elliott Hughes8cbc8bc2011-10-04 11:19:45 -0700666export TEST_NAME=`basename ${test_dir}`
667
Roland Levillain0d5a2812015-11-13 10:07:31 +0000668# arch_supports_read_barrier ARCH
669# -------------------------------
670# Return whether the Optimizing compiler has read barrier support for ARCH.
671function arch_supports_read_barrier() {
Roland Levillain22ccc3a2015-11-24 13:10:05 +0000672 # Optimizing has read barrier support for ARM, ARM64, x86 and x86-64 at the
Roland Levillain0d5a2812015-11-13 10:07:31 +0000673 # moment.
Roland Levillain22ccc3a2015-11-24 13:10:05 +0000674 [ "x$1" = xarm ] || [ "x$1" = xarm64 ] || [ "x$1" = xx86 ] || [ "x$1" = xx86_64 ]
Roland Levillain0d5a2812015-11-13 10:07:31 +0000675}
676
David Brazdil4846d132015-01-15 19:07:08 +0000677# Tests named '<number>-checker-*' will also have their CFGs verified with
678# Checker when compiled with Optimizing on host.
679if [[ "$TEST_NAME" =~ ^[0-9]+-checker- ]]; then
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100680 # Jack does not necessarily generate the same DEX output than dx. Because these tests depend
681 # on a particular DEX output, keep building them with dx for now (b/19467889).
682 USE_JACK="false"
683
David Brazdil5cc343d2015-10-08 11:35:32 +0100684 if [ "$runtime" = "art" -a "$image_suffix" = "-optimizing" ]; then
Roland Levillain0d5a2812015-11-13 10:07:31 +0000685 # Optimizing has read barrier support for certain architectures
686 # only. On other architectures, compiling is disabled when read
687 # barriers are enabled, meaning that we do not produce a CFG file
688 # as a side-effect of compilation, thus the Checker assertions
689 # cannot be checked. Disable Checker for those cases.
690 #
691 # TODO: Enable Checker when read barrier support is added to more
692 # architectures (b/12687968).
693 if [ "x$ART_USE_READ_BARRIER" = xtrue ] \
694 && (([ "x$host_mode" = "xyes" ] \
695 && ! arch_supports_read_barrier "$host_arch_name") \
696 || ([ "x$target_mode" = "xyes" ] \
697 && ! arch_supports_read_barrier "$target_arch_name")); then
698 run_checker="no"
David Brazdil80fb3942015-07-23 11:53:42 +0100699 # In no-prebuild mode, the compiler is only invoked if both dex2oat and
700 # patchoat are available. Disable Checker otherwise (b/22552692).
Roland Levillain0d5a2812015-11-13 10:07:31 +0000701 elif [ "$prebuild_mode" = "yes" ] \
702 || [ "$have_patchoat" = "yes" -a "$have_dex2oat" = "yes" ]; then
David Brazdil80fb3942015-07-23 11:53:42 +0100703 run_checker="yes"
David Brazdil5cc343d2015-10-08 11:35:32 +0100704
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100705 if [ "$target_mode" = "no" ]; then
706 cfg_output_dir="$tmp_dir"
David Brazdil5cc343d2015-10-08 11:35:32 +0100707 checker_args="--arch=${host_arch_name^^}"
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100708 else
709 cfg_output_dir="$DEX_LOCATION"
David Brazdil5cc343d2015-10-08 11:35:32 +0100710 checker_args="--arch=${target_arch_name^^}"
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100711 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100712
713 if [ "$debuggable" = "yes" ]; then
714 checker_args="$checker_args --debuggable"
715 fi
716
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100717 run_args="${run_args} -Xcompiler-option --dump-cfg=$cfg_output_dir/$cfg_output \
David Brazdil80fb3942015-07-23 11:53:42 +0100718 -Xcompiler-option -j1"
719 fi
David Brazdil4846d132015-01-15 19:07:08 +0000720 fi
721fi
722
Mathieu Chartier031768a2015-08-27 10:25:02 -0700723if [ "$runtime" != "jvm" ]; then
724 run_args="${run_args} --testlib ${testlib}"
725fi
726
Ian Rogers997f0f92014-06-21 22:58:05 -0700727# To cause tests to fail fast, limit the file sizes created by dx, dex2oat and ART output to 2MB.
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100728build_file_size_limit=2048
729run_file_size_limit=2048
Alex Light4694e822016-01-22 10:09:40 -0800730
731# Add tests requiring a higher ulimit to this list. Ulimits might need to be raised to deal with
732# large amounts of expected output or large generated files.
733if echo "$test_dir" | grep -Eq "(083|089|961|964|971)" > /dev/null; then
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100734 build_file_size_limit=5120
735 run_file_size_limit=5120
Ian Rogers997f0f92014-06-21 22:58:05 -0700736fi
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100737if [ "$run_checker" = "yes" -a "$target_mode" = "yes" ]; then
738 # We will need to `adb pull` the .cfg output from the target onto the host to
739 # run checker on it. This file can be big.
Roland Levillain22ccc3a2015-11-24 13:10:05 +0000740 build_file_size_limit=24576
741 run_file_size_limit=24576
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100742fi
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100743if [ ${USE_JACK} = "false" ]; then
744 # Set ulimit if we build with dx only, Jack can generate big temp files.
745 if ! ulimit -S "$build_file_size_limit"; then
Alex Light91de25f2015-10-28 17:00:06 -0700746 err_echo "ulimit file size setting failed"
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100747 fi
Ian Rogers997f0f92014-06-21 22:58:05 -0700748fi
749
jeffhao5d1ac922011-09-29 17:41:15 -0700750good="no"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000751good_build="yes"
752good_run="yes"
jeffhao5d1ac922011-09-29 17:41:15 -0700753if [ "$dev_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000754 "./${build}" $build_args 2>&1
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700755 build_exit="$?"
756 echo "build exit status: $build_exit" 1>&2
757 if [ "$build_exit" = '0' ]; then
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100758 if ! ulimit -S "$run_file_size_limit"; then
Alex Light91de25f2015-10-28 17:00:06 -0700759 err_echo "ulimit file size setting failed"
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100760 fi
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800761 echo "${test_dir}: running..." 1>&2
762 "./${run}" $run_args "$@" 2>&1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700763 run_exit="$?"
Calin Juravle3cf48772015-01-26 16:47:33 +0000764
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800765 if [ "$run_exit" = "0" ]; then
Calin Juravle3cf48772015-01-26 16:47:33 +0000766 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100767 if [ "$target_mode" = "yes" ]; then
768 adb pull $cfg_output_dir/$cfg_output &> /dev/null
769 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100770 "$checker" $checker_args "$cfg_output" "$tmp_dir" 2>&1
Calin Juravle3cf48772015-01-26 16:47:33 +0000771 checker_exit="$?"
772 if [ "$checker_exit" = "0" ]; then
773 good="yes"
774 fi
Alex Light91de25f2015-10-28 17:00:06 -0700775 err_echo "checker exit status: $checker_exit"
Calin Juravle3cf48772015-01-26 16:47:33 +0000776 else
777 good="yes"
778 fi
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800779 fi
Calin Juravle3cf48772015-01-26 16:47:33 +0000780 echo "run exit status: $run_exit" 1>&2
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700781 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700782elif [ "$update_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000783 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700784 build_exit="$?"
785 if [ "$build_exit" = '0' ]; then
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100786 if ! ulimit -S "$run_file_size_limit"; then
Alex Light91de25f2015-10-28 17:00:06 -0700787 err_echo "ulimit file size setting failed"
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100788 fi
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800789 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700790 "./${run}" $run_args "$@" >"$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000791 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100792 if [ "$target_mode" = "yes" ]; then
793 adb pull $cfg_output_dir/$cfg_output &> /dev/null
794 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100795 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000796 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700797 sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}"
798 good="yes"
799 else
Alex Light91de25f2015-10-28 17:00:06 -0700800 cat "$build_output" 1>&${real_stderr} 1>&2
801 err_echo "build exit status: $build_exit"
jeffhao5d1ac922011-09-29 17:41:15 -0700802 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700803elif [ "$build_only" = "yes" ]; then
804 good="yes"
David Brazdil4846d132015-01-15 19:07:08 +0000805 "./${build}" $build_args >"$build_output" 2>&1
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700806 build_exit="$?"
807 if [ "$build_exit" '!=' '0' ]; then
808 cp "$build_output" "$output"
809 echo "build exit status: $build_exit" >>"$output"
810 diff --strip-trailing-cr -q "$expected" "$output" >/dev/null
811 if [ "$?" '!=' "0" ]; then
812 good="no"
Alex Light91de25f2015-10-28 17:00:06 -0700813 err_echo "BUILD FAILED For ${TEST_NAME}"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700814 fi
815 fi
Tsu Chiang Chuang379e2f52013-08-20 12:24:52 -0700816 # Clean up extraneous files that are not used by tests.
Tsu Chiang Chuang0160d992013-09-13 14:17:42 -0700817 find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700818 exit 0
jeffhao5d1ac922011-09-29 17:41:15 -0700819else
David Brazdil4846d132015-01-15 19:07:08 +0000820 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700821 build_exit="$?"
822 if [ "$build_exit" = '0' ]; then
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100823 if ! ulimit -S "$run_file_size_limit"; then
Alex Light91de25f2015-10-28 17:00:06 -0700824 err_echo "ulimit file size setting failed"
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100825 fi
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800826 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700827 "./${run}" $run_args "$@" >"$output" 2>&1
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000828 run_exit="$?"
829 if [ "$run_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700830 err_echo "run exit status: $run_exit"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000831 good_run="no"
David Brazdil4846d132015-01-15 19:07:08 +0000832 elif [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100833 if [ "$target_mode" = "yes" ]; then
834 adb pull $cfg_output_dir/$cfg_output &> /dev/null
835 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100836 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000837 checker_exit="$?"
838 if [ "$checker_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700839 err_echo "checker exit status: $checker_exit"
David Brazdil4846d132015-01-15 19:07:08 +0000840 good_run="no"
841 else
842 good_run="yes"
843 fi
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000844 else
845 good_run="yes"
846 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700847 else
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000848 good_build="no"
jeffhao5d1ac922011-09-29 17:41:15 -0700849 cp "$build_output" "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700850 echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" >> "$output"
851 echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$output"
Ian Rogersd9ad27d2014-10-27 13:48:21 -0700852 echo "Args: ${args}" >> "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700853 echo "build exit status: $build_exit" >> "$output"
Andreas Gampe5c114902014-10-27 17:03:58 -0700854 max_name_length=$(getconf NAME_MAX ${tmp_dir})
855 echo "Max filename (NAME_MAX): ${max_name_length}" >> "$output"
856 max_path_length=$(getconf PATH_MAX ${tmp_dir})
Andreas Gampe602fbcd2014-10-27 17:06:29 -0700857 echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700858 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700859 ./$check_cmd "$expected" "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700860 if [ "$?" = "0" ]; then
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000861 if [ "$good_build" = "no" -o "$good_run" = "yes" ]; then
862 # output == expected
863 good="yes"
864 echo "${test_dir}: succeeded!" 1>&2
865 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700866 fi
867fi
868
jeffhao5d1ac922011-09-29 17:41:15 -0700869(
Alex Lightbfac14a2014-07-30 09:41:21 -0700870 if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then
jeffhao5d1ac922011-09-29 17:41:15 -0700871 echo "${test_dir}: FAILED!"
872 echo ' '
873 echo '#################### info'
874 cat "${td_info}" | sed 's/^/# /g'
875 echo '#################### diffs'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -0700876 diff --strip-trailing-cr -u "$expected" "$output" | tail -n 3000
jeffhao5d1ac922011-09-29 17:41:15 -0700877 echo '####################'
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700878 if [ "$strace" = "yes" ]; then
879 echo '#################### strace output'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -0700880 tail -n 3000 "$tmp_dir/$strace_output"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700881 echo '####################'
882 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700883 echo ' '
884 fi
Alex Lightbfac14a2014-07-30 09:41:21 -0700885
Alex Light91de25f2015-10-28 17:00:06 -0700886) 2>&${real_stderr} 1>&2
Alex Lightbfac14a2014-07-30 09:41:21 -0700887
888# Clean up test files.
Igor Murashkin05f30e12015-06-10 15:57:17 -0700889if [ "$always_clean" = "yes" -o "$good" = "yes" ] && [ "$never_clean" = "no" ]; then
Alex Lightbfac14a2014-07-30 09:41:21 -0700890 cd "$oldwd"
891 rm -rf "$tmp_dir"
892 if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then
893 adb shell rm -rf $DEX_LOCATION
894 fi
895 if [ "$good" = "yes" ]; then
896 exit 0
897 fi
898fi
899
900
901(
902 if [ "$always_clean" = "yes" ]; then
903 echo "${TEST_NAME} files deleted from host "
904 if [ "$target_mode" == "yes" ]; then
905 echo "and from target"
906 fi
907 else
908 echo "${TEST_NAME} files left in ${tmp_dir} on host"
909 if [ "$target_mode" == "yes" ]; then
910 echo "and in ${DEX_LOCATION} on target"
911 fi
Brian Carlstrom105215d2012-06-14 12:50:44 -0700912 fi
913
Alex Light91de25f2015-10-28 17:00:06 -0700914) 2>&${real_stderr} 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700915
916exit 1